<?php

namespace BetterStudio\Framework\Core\Integration;

// use integration APIs
use BetterStudio\Component\Integration\{
	Control as ControlIntegration
};

// use standard APIs
use BetterStudio\Component\Standard\{
	Control as ControlStandard
};

/**
 * @since 4.0.0
 */
class ControlsIntegration implements ControlIntegration\ControlIntegration {

	/**
	 * Store BlockAssets instance
	 *
	 * @var ControlStandard\ControlAssets
	 * @since 4.0.0
	 */
	protected $assets;


	/**
	 * @since 4.0.0
	 */
	public function __construct() {

		$this->assets = new ControlStandard\ControlAssets( EnqueueScript::instance(), EnqueueStyle::instance() );
	}

	/**
	 * @param ControlStandard\StandardControl $control
	 *
	 * @since 4.0.0
	 * @return bool
	 */
	public function register( ControlStandard\StandardControl $control ): bool {

		$this->assets->enqueue_js( $control );
		$this->assets->enqueue_css( $control );

		return true;
	}

	/**
	 * @since 4.0.0
	 * @return bool
	 */
	public static function is_enable(): bool {

		return is_admin();
	}
}
