<?php

$version = '4.1.0-dev';

if ( ! class_exists( 'Better_Library_Loader' ) ) {

	require __DIR__ . '/loader.php';
}

if ( ! function_exists( 'better_framework_load' ) ) {

	// Backward compatibility
	// Prevent bf<4 loaders to include BF by their own loader class
	add_filter( 'better-framework/loader', '__return_false', PHP_INT_MAX );
	remove_action( 'after_setup_theme', array( 'BetterFramework_Oculus_Loader', 'setup_library' ), 11 );
	remove_action( 'after_setup_theme', array( 'BetterFramework_Oculus_Loader', 'setup_library' ) );

	/**
	 * @param array $framework
	 */
	function better_framework_load( array $framework ) {

		if ( empty( $framework['path'] ) ) {

			$framework['path'] = __DIR__;
		}

		if ( empty( $framework['uri'] ) ) {

			$framework['uri'] = site_url(
				str_replace(
					[ rtrim( ABSPATH, '/' ), '\\' ],
					[ '', '/' ],
					$framework['path']
				) );
		}

		define( 'BF_URI', trailingslashit( $framework['uri'] ) );
		define( 'BF_PATH', trailingslashit( $framework['path'] ) );
		define( 'BF_VERSION', $framework['version'] );

		require __DIR__ . '/class-better-framework.php';

		/**
		 * Fires after BetterFramework fully loaded.
		 */
		do_action( 'better-framework/after_setup' );
	}
}

/**
 * @param array $params {
 *
 * @type string $uri
 * @type string $path
 * }
 */
return static function ( array $params ) use ( $version ) {

	$params['version'] = $version;

	$instance = Better_Library_Loader::instance( 'better-framework', [ 'priority' => 90 ] );
	$instance->introduce( $version, 'better_framework_load', $params );

	return $instance;
};
