<?php declare( strict_types=1 );

namespace BetterStudio\Component\Integration\Block\UnitTest;


use BetterStudio\Component\Integration\{
	Block as Module
};

// use standard APIs
use BetterStudio\Component\Standard\{
	Block as BlockStandards
};

// use Test APIs
use BetterStudio\Component\TestUtil\{
	Sample\Block as SampleBlock,
	TestCase
};


class TestSetup extends TestCase {

	/**
	 * @test
	 */
	public function itShouldFireRegisterMethodPerBlocks() {

		$sample_block     = new SampleBlock\SampleBlock();
		$integration_mock = $this->mock->block_integration_mock();

		$integration_mock->expects( $this->once() )
		                 ->method( 'register' )
		                 ->with( $this->equalTo( $sample_block ) );

		BlockStandards\BlockStorage::register( $sample_block->block_id(), $sample_block );

		Module\Setup::instance()->register( $integration_mock );
	}

	/**
	 * @test
	 */
	public function itShouldNotRegisterWhenBlockIdIsNotProvidedInTheBlocksId() {

		$block_mock = $this->mock->block_integration_mock();

		$block_mock->expects( $this->never() )
		           ->method( 'register' );

		Module\Setup::instance()->integrate();
	}

	function tearDown() {

		parent::tearDown();

		BlockStandards\BlockStorage::flush();
	}
}
