<?php declare( strict_types=1 );

namespace BetterStudio\Component\TestUtil;

use BetterStudio\Asset\Enqueue;

//
use PHPUnit\Framework\{
	TestCase,
	MockObject
};

final class MockAPI extends TestCase {

	/**
	 * @var array
	 */
	protected $storage = [];

	public function block_integration_full_mock() {

		$script_mock      = self::enqueue_script_mock();
		$style_mock       = self::enqueue_style_mock();
		$integration_mock = self::block_integration_mock();

		return [ $integration_mock, $script_mock, $style_mock ];
	}


	public function block_integration_mock() {

		return $this->mock(
			$this->createTestProxy(
				Sample\SampleIntegration::class
			)
		);
	}

	public function enqueue_script_mock() {

		return $this->mock( $this->createTestProxy( Enqueue\EnqueueScript::class ) );
	}


	/**
	 * @return Enqueue\EnqueueStyle|MockObject\MockObject
	 */
	public function enqueue_style_mock() {

		return $this->mock( $this->createTestProxy( Enqueue\EnqueueStyle::class ) );
	}


	private function mock( MockObject\MockObject $mock ): MockObject\MockObject {

		$this->storage[] = $mock;

		return $mock;
	}

	/**
	 * @return array
	 */
	public function mocks(): array {

		return $this->storage;
	}
}
