<?php declare( strict_types=1 );

namespace BetterStudio\Component\TestUtil\Sample\Block;

use BetterStudio\Component\Standard\Block as BlockStandards;

/**
 * Duplicated
 */
class SampleBlockNoAssets implements
	BlockStandards\BlockInterface,
	BlockStandards\HaveOptions,
	BlockStandards\HaveControls {


	/**
	 * @var array
	 */
	protected $fields;

	/**
	 * @var array
	 */
	protected $defaults;

	public function __construct( array $fields = [], array $defaults = [] ) {

		$this->fields   = $fields;
		$this->defaults = $defaults;
	}


	/**
	 * @since 1.0.0
	 * @return array
	 */
	public function fields(): array {

		return $this->fields;
	}

	public function defaults(): array {


		return $this->defaults;
	}

	public function block_id(): string {

		return 'block-id';
	}

	public function block_name(): string {

		return 'block-name';
	}

	public function block_render( array $settings ): string {

		return '<h2>Markup</h2>';
	}

	public function options(): array {

		return [
			'categories' => [ 'block', 'categories' ],
		];
	}

	public function block_icon(): string {

		return '';
	}
}