<?php declare( strict_types=1 );

namespace BetterStudio\Component\TestUtil\Sample\Control;

use BetterStudio\Component\Standard\Control;

class SampleControl extends Control\StandardControl implements
	Control\HaveStyles,
	Control\HaveScripts {

	/**
	 * @var array
	 */
	protected $styles = [];

	/**
	 * @var array
	 */
	protected $scripts = [];

	public function control_type(): string {

		return 'control-id';
	}

	public function load_scripts( array $scripts ) {

		$this->scripts = $scripts;
	}

	public function scripts_list(): array {

		return $this->scripts;
	}

	public function load_styles( array $styles ) {

		$this->styles = $styles;
	}

	public function styles_list(): array {

		return $this->styles;
	}

	public function control_data_set( $value ): bool {

		return true;
	}

	public function control_data_get() {

		return 'value';
	}

	public function template_dir(): string {

		return 'x';
	}
}
