<?php declare( strict_types=1 );

namespace BetterStudio\Component\TestUtil\Sample;

// use standard APIs
use BetterStudio\Component\Standard\{
	Block as BlockStandards
};

class SampleIntegration implements BlockStandards\BlockIntegrationInterface {

	protected $callback;

	/**
	 * @param callable $callback
	 */
	public function register_callback( callable $callback ):void {

		$this->callback = $callback;
	}

	/**
	 * @param BlockStandards\BlockInterface $block
	 *
	 * @since 1.0.0
	 * @return bool
	 */
	public function register( BlockStandards\BlockInterface $block ): bool {

		$callback = $this->callback;

		return isset( $callback ) ? $callback( $block ) : false;
	}

	/**
	 * List of blocks id that will be used/rendered in the page.
	 *
	 * @hooked template_redirect
	 *
	 * @since  1.0.0
	 * @return string
	 */
	public function blocks_id(): string {

		return 'all';
	}
}
