<?php declare( strict_types=1 );

namespace BetterStudio\Component\TestUtil;

// use standard APIs
use BetterStudio\Component\Standard\{
	Block as BlockStandards
};

use BetterStudio\Component\TestUtil;


class TestCase extends \BetterStudioTest\TestCases\TestCase {

	protected $mock;

	function setUp() {
		parent::setUp();

		$this->mock = new TestUtil\MockAPI();
	}


	public function register_block( BlockStandards\BlockInterface $block ): bool {

		BlockStandards\BlockStorage::register( $block->block_id(), $block );

		return true;
	}

	protected function runTest() {

		$result = parent::runTest();

		array_map( [ $this, 'registerMockObject' ], $this->mock->mocks() );

		return $result;
	}
}
