<?php declare( strict_types=1 );

namespace BetterStudio\Component\Integration\Control\UnitTest;

// use test APIs
use BetterStudio\Component\TestUtil;
use PHPUnit\Framework\{
	MockObject
};

abstract class ControlIntegrationTestCase extends TestUtil\TestCase {

	function setUp() {

		parent::setUp();

		add_filter( 'better-studio/controls/integration/list', static function ( $list ) {

			$list[] = SampleIntegration::class;

			return $list;
		}, 9999 );
	}

	/**
	 * @since 1.0.0
	 * @return MockObject\MockObject
	 */
	public function control_integration_mock(): MockObject\MockObject {

		$mock = $this->getMockBuilder( SampleIntegration::class )
		             ->setMethods( [ 'register' ] )
		             ->getMock();

		// Register integration class
		add_filter( 'better-studio/controls/integration/list', static function () use ( $mock ) {

			return [ $mock ];
		}, 9999 );

		return $mock;
	}
}
