// @flow

export type CacheKey = String | Number | Object | Function;

export interface CacheInterface {

    cache_exists(key: CacheKey): boolean;

    cache_set(key: CacheKey, value: mixed): boolean;

    cache_get(key: CacheKey): mixed | void;

    cache_delete(key: CacheKey): boolean;

    cache_flush(): boolean;
}

export class CacheMemory implements CacheInterface {

    storage: Map<CacheKey, mixed>;

    constructor() {

        this.storage = new Map<CacheKey, mixed>;
    }

    cache_exists(key: CacheKey): boolean {

        return this.storage.has(key);
    }

    cache_get(key: CacheKey): mixed | void {

        return this.storage.get(key);
    }

    cache_set(key: CacheKey, value: mixed): boolean {

        this.storage.set(key, value);

        return true;
    }

    cache_delete(key: CacheKey): boolean {

        return this.storage.delete(key);
    }

    cache_flush(): boolean {

        this.storage.clear();

        return true;
    }
}
