import classnames from 'classnames'
import lodash from 'lodash'

function formatAttributes(attributes) {

    if (Array.isArray(attributes.className)) {

        attributes.className = classnames(attributes.className);
    }

    return lodash.mapValues(attributes,(value) => {

        return typeof value === "object" ? JSON.stringify(value) : value;
    });
}

export function container_attributes(props, className = [], customAttributes = {}) {

    const attributes = lodash.extend(props.container_attributes || {}, customAttributes || {});
    attributes.className = lodash.uniq(lodash.concat(
        attributes.className || [],
        attributes['class'] || [],
        props.classes || [],
        className || []
    ));


    return formatAttributes(attributes);
}