import $ from "jquery";

export default {

    is_blocked: function ($element) {

        if($element instanceof Element) {
            $element = $($element);
        }

        return !!$element.data('better-studio-el-blocked');
    },

    block: function ($element) {

        if($element instanceof Element) {
            $element = $($element);
        }

        if (this.is_blocked($element)) {
            return;
        }

        $element.data('better-studio-el-blocked', true);

        $element.prepend('<div class="better-studio-overlay" style="z-index:10;display:none;border:none;margin:0;padding:0;width:100%;height:100%;top:0;left:0;display:none;position: absolute;background:rgba(255,255,255,0.4)"></div>');

        $(".better-studio-overlay",$element).fadeIn();
    },

    unblock: function ($element) {

        if($element instanceof Element) {
            $element = $($element);
        }

        if (!this.is_blocked($element)) {
            return;
        }

        $element.data('better-studio-el-blocked', false);

        $(".better-studio-overlay", $element).fadeOut(function () {
            $(this).remove();
        });
    },


    // Panel loader
    // status: loading, succeed, error
    panel_loader: function( status, message = "" ){

        var $bf_loading = $('.bf-loading');

        if($bf_loading.length === 0 ) {

            $(document.body)
                .append('<div class="bf-loading">\n    <div class="loader">\n        <div class="loader-icon in-loading-icon "><i class="dashicons dashicons-update"></i></div>\n        <div class="loader-icon loaded-icon"><i class="dashicons dashicons-yes"></i></div>\n        <div class="loader-icon not-loaded-icon"><i class="dashicons dashicons-no-alt"></i></div>\n        <div class="message">An Error Occurred!</div>\n    </div>\n</div>')
                .append('<style>\n    .bf-loading {\n        position: fixed;\n        top: 0;\n        left: 0;\n        width: 100%;\n        height: 100%;\n        background-color: #636363;\n        background-color: rgba(0, 0, 0, 0.41);\n        display: none;\n        z-index: 99999;\n    }\n\n    .bf-loading .loader {\n        width: 300px;\n        height: 180px;\n        position: absolute;\n        top: 50%;\n        left: 50%;\n        margin-top: -90px;\n        margin-left: -150px;\n        text-align: center;\n    }\n\n    .bf-loading.not-loaded,\n    .bf-loading.loaded,\n    .bf-loading.in-loading {\n        display: block;\n    }\n\n    .bf-loading.in-loading .loader {\n        color: white;\n    }\n\n    .bf-loading.loaded .loader {\n        color: #27c55a;\n    }\n\n    .bf-loading.not-loaded .loader {\n        color: #ff0000;\n    }\n\n    .bf-loading .loader .loader-icon {\n        font-size: 30px;\n        -webkit-transition: all 0.2s ease;\n        -moz-transition: all 0.2s ease;\n        -ms-transition: all 0.2s ease;\n        -o-transition: all 0.2s ease;\n        transition: all .2s ease;\n        opacity: 0;\n        border-radius: 10px;\n        background-color: #333;\n        background-color: rgba(51, 51, 51, 0.86);\n        width: 60px;\n        height: 60px;\n        line-height: 60px;\n        margin-top: 20px;\n        display: none;\n        position: absolute;\n        left: 50%;\n        margin-left: -30px;\n    }\n\n    .bf-loading .loader .loader-icon .dashicons,\n    .bf-loading .loader .loader-icon .dashicons-before:before {\n        font-size: 55px;\n        line-height: 60px;\n        width: 60px;\n        height: 60px;\n        text-align: center;\n    }\n\n    .bf-loading.in-loading .loader .loader-icon.in-loading-icon,\n    .bf-loading.in-loading.loader .loader-icon.in-loading-icon {\n        opacity: 1;\n        display: inline-block;\n    }\n\n    .bf-loading.in-loading .loader .loader-icon.in-loading-icon .dashicons,\n    .bf-loading.in-loading .loader .loader-icon.in-loading-icon .dashicons-before:before {\n        -webkit-animation: spin 1.15s linear infinite;\n        -moz-animation: spin 1.15s linear infinite;\n        animation: spin 1.15s linear infinite;\n        font-size: 30px;\n    }\n\n    .bf-loading.loaded .loader .loader-icon.loaded-icon {\n        opacity: 1;\n        display: inline-block;\n        font-size: 50px;\n    }\n\n    .bf-loading.loaded .loader .loader-icon.loaded .dashicons,\n    .bf-loading.loaded .loader .loader-icon.loaded .dashicons-before:before {\n        width: 57px;\n    }\n\n    .bf-loading.not-loaded .loader .loader-icon.not-loaded-icon {\n        opacity: 1;\n        display: inline-block;\n    }\n\n    .bf-loading.not-loaded .loader .loader-icon.not-loaded-icon .dashicons,\n    .bf-loading.not-loaded .loader .loader-icon.not-loaded-icon .dashicons-before:before {\n        font-size: 50px;\n        line-height: 62px;\n    }\n\n    .bf-loading .loader .message {\n        display: none;\n        color: #ff0000;\n        font-size: 12px;\n        line-height: 24px;\n        min-width: 100px;\n        max-width: 300px;\n        left: auto;\n        right: auto;\n        text-align: center;\n        background-color: #333;\n        background-color: rgba(51, 51, 51, 0.86);\n        border-radius: 5px;\n        padding: 4px 20px;\n        margin-top: 90px;\n    }\n\n    .bf-loading.with-message .loader .message {\n        display: inline-block;\n    }\n\n    .bf-loading.loaded .loader .message {\n        color: #27c55a;\n    }\n\n    .bf-loading.in-loading .loader .message {\n        color: #fff;\n    }\n\n    @-moz-keyframes spin {\n        100% {\n            -moz-transform: rotate(360deg);\n        }\n    }\n\n    @-webkit-keyframes spin {\n        100% {\n            -webkit-transform: rotate(360deg);\n        }\n    }\n\n    @keyframes spin {\n        100% {\n            -webkit-transform: rotate(360deg);\n            transform: rotate(360deg);\n        }\n    }\n</style>');

            $bf_loading = $('.bf-loading');
        }

        if( status === 'loading'){

            $bf_loading.removeClass().addClass('bf-loading in-loading');

            if( message !== '' ){
                $bf_loading.find('.message').html(message);
                $bf_loading.addClass('with-message');
            }
        } else if(status === 'error'){

            $bf_loading.removeClass().addClass('bf-loading not-loaded');

            if( message !== '' ){
                $bf_loading.find('.message').html(message);
                $bf_loading.addClass('with-message');
            }

            setTimeout(function(){
                $bf_loading.removeClass('not-loaded');
                $bf_loading.find('.message').html('');
                $bf_loading.removeClass('with-message');
            },1500);

        }else if(status === 'succeed'){

            $bf_loading.removeClass().addClass('bf-loading loaded');

            if( message !== '' ){
                $bf_loading.find('.message').html(message);
                $bf_loading.addClass('with-message');
            }

            setTimeout(function(){
                $bf_loading.removeClass('loaded');
                $bf_loading.find('.message').html('');
                $bf_loading.removeClass('with-message');
            },1000);

        }else if( status === 'hide' ){

            setTimeout(function(){
                $bf_loading.removeClass(' in-loading');
                $bf_loading.find('.message').html('');
                $bf_loading.removeClass('with-message');
            },500 );
        }

    },
};