import UI from '../../js/UI'
import {fetch_data} from "../../js/AjaxRequest"
import $ from 'jquery'

export default function (context, onChange) {

    var $context = $(context);

    $context.on('click', '.bf-ajax_action-field-container .bf-action-button', function (e) {

        var $this = $(this);

        e.preventDefault();

        UI.panel_loader('loading');

        var _confirm_msg = $this.data('confirm');

        if (typeof _confirm_msg != "undefined")
            if (!confirm(_confirm_msg)) {
                UI.panel_loader('hide');
                return false;
            }

        var data = {
            callback: $this.data('callback'),
            args: $this.data('args'),
            call_token: $this.data('token')
        };
        /**
         * todo: use internal hooks
         */
        $(document).trigger('ajax-action-field-data', [data]);

        fetch_data('ajax_action', data).then((data) => {

            try {

                if (!data) {
                    UI.panel_loader('error');
                    return;
                }

                var event = $this.data('event');

                event && $(document).trigger(event, [data, $this]);

                if (data.status === 'succeed') {
                    if (typeof data.msg !== 'undefined') {

                        UI.panel_loader('succeed', data.msg);

                    } else {

                        UI.panel_loader('succeed');
                    }
                } else {
                    if (typeof data.msg !== 'undefined') {
                        UI.panel_loader('error', data.msg);
                    } else {
                        UI.panel_loader('error');
                    }
                }

                data.refresh && location.reload();

            } catch (error) {
                console.error(error);
            }
        }).catch(() => UI.panel_loader('error'));
    });

    return {$context};
}