/**
 * TODO: Refactor
 */

import {fetch_data,load_secure_props} from '../../js/AjaxRequest'
import $ from 'jquery'
import _ from 'lodash'
import UI from "../../js/UI"

export default function (context, onChange) {

    var $context = $(context);
    var _object_ = {};
    _object_.preloader = $context.find('.bf-search-loader');
    _object_.hidden_field = $context.find('input[type=hidden]');
    _object_.result_box = $context.find('.bf-ajax-suggest-search-results');
    _object_._this = this;
    _object_.$context = $context;


    var bf_ajax_input_timeOut = null;

    var bf_ajax_input_interval = 850;


    var saveValue = function (value) {

        _object_.hidden_field.val(value);
        _object_.hidden_field.change()[0].dispatchEvent(new Event('change', {bubbles: true}));

        // trigger onChange
        onChange(value);
    };

    var generateResultItems = function (data) {

        var result = '';

        $.each(data, function (index, item) {

            var id, label
            if (_.isObject(item)) {

                id = item.id;
                label = item.label;
            } else {

                id = index;
                label = item;
            }

            result += '<li class="ui-state-default" data-id="' + id + '">' + label + ' <span class="bf-icon del-icon del"></span></li>';
        });

        return result;
    };

    var appendHTML = function (html) {

        _object_.result_box.append(html);
    };

    $context.on('keyup.ajaxselect', '.bf-ajax-suggest-input', function (e) {

        var _this = $(e.target);


        _this.removeResults = function () {
            _object_.result_box.find('li').remove();
        };

        _this.get = function (key, callback) {

            var is_repeater = _this.parent().is('.bf-repeater-controls-option'),
                form_data = {
                    field_ID: _object_.hidden_field.attr('name'),
                    key: key,
                    is_repeater: is_repeater ? 1 : 0,
                    callback: _object_.hidden_field.data('callback'),
                    token: _object_.hidden_field.data('token'),
                    exclude: _object_.hidden_field.val(),
                };

            if (is_repeater) {
                form_data.repeater_id = _this.closest('.bf-nonrepeater-section').data('id');
            }

            fetch_data('ajax_select', form_data)
                .then((response) => callback(response.data))
                .catch(() => callback(false));
        };

        clearTimeout(bf_ajax_input_timeOut);

        bf_ajax_input_timeOut = setTimeout(function () {

            _object_.preloader.addClass('loader');

            _this.get(_this[0].value, function (data) {

                _object_.preloader.removeClass('loader');

                if (data === false) {
                    alert('Something Wrong Happened!');
                    return;
                }

                _object_.$context.find('.bf-ajax-suggest-controls').sortable({

                    update: function (event, ui) {
                        var value = '';

                        _object_.$context.find('.bf-ajax-suggest-controls').find('li:not(".ui-sortable-placeholder")').each(function () {
                            value += $(this).data('id') + ','
                        });

                        saveValue(value.replace(',,', ',').replace(/^,+/, '').replace(/,+$/, ''));
                    }
                });

                if (data == -1) {
                    return;
                }

                _this.removeResults(); // Remove Current Results

                appendHTML(generateResultItems(data)); // Append The HTMLs

                _object_.result_box.fadeIn();

            })

        }, bf_ajax_input_interval);
    });

    $context.on('blur.ajaxselect', '.bf-ajax-suggest-input', function () {

        _object_.result_box.fadeOut();
    });

    $context.on('focus.ajaxselect', '.bf-ajax-suggest-input', function () {

        if (_object_.result_box.find('li').size() > 0)
            _object_.result_box.fadeIn();

    });

    $context.on('click.ajaxselect', '.bf-ajax-suggest-search-results li', function (e) {

        var _this = $(e.target);
        _object_.result_box.fadeOut();

        if (_object_.$context.find('.bf-ajax-suggest-controls').find('li[data-id="' + _this.data('id') + '"]').exist())
            return true;

        var value = _object_.hidden_field.val() === undefined ? [] : _object_.hidden_field.val().split(',');

        value.push(_this.data('id'));

        _object_.$context.find('.bf-ajax-suggest-controls').append(e.target.outerHTML);

        saveValue($.array_unique(value).join(',').replace(',,', ',').replace(/^,+/, '').replace(/,+$/, ''));
        $(this).remove();

        return false;

    });

    $context.on('click.ajaxselect', '.bf-ajax-suggest-controls li .del', function (e) {

        if (confirm('Are You Sure?')) {
            var _new,
                _this = $(e.target).parent(),
                _array,
                ID = _this.data('id');


            _this.remove();

            _array = _object_.hidden_field.val().split(',');

            _new = $.grep(_array, function (value) {
                return value != ID;
            });

            saveValue(_new.join(',').replace(',,', ',').replace(/^,+/, '').replace(/,+$/, ''));
        }
    });

    $.fn.sortable && $context.find('.bf-ajax-suggest-controls').sortable({
        update: function (event, ui) {
            var value = '';

            _object_.$context.find('.bf-ajax-suggest-controls').find('li:not(".ui-sortable-placeholder")').each(function () {
                value += $(this).data('id') + ','
            });

            saveValue(value.replace(',,', ',').replace(/^,+/, '').replace(/,+$/, ''));
        }
    });

    // fetch callback values from server if needed
    var currentValue = _object_.hidden_field.val();
    var $display = $context.find('.bf-ajax-suggest-controls');

    if (!_.isEmpty(currentValue) && $display.find('li:first').length === 0) {

        UI.block($context);

        var params = _object_.hidden_field.data();
        params.value = currentValue;

        load_secure_props("ajax_select", params, `ajax_select:${currentValue}`).then((res) => {

            UI.unblock($context);

            res?.values && $display.append(
                generateResultItems(
                    res.values
                )
            );
        });
    }

    return _object_;
}
