import {Component} from "@wordpress/element"
import Icon from "../../Icon"
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    shouldComponentUpdate() {

        return false;
    }

    render() {

        const props = this.props;

        const LiValues = props.values ? props.values.map(function (v) {

            return (
                <li data-id={v.id}>
                    #{v.label}#
                    <span className="bf-icon del del-icon"></span>
                </li>
            )
        }) : [];

        return (
            <div {...container_attributes(props,"bf-ajax_select-field-container")}>

                <div className="bf-ajax_select-input-container">
                    <input type="text" className="bf-ajax-suggest-input" placeholder={props.placeholder}/>

                    <span className="bf-search-loader">
                        <Icon icon="fa-search"/>
                    </span>
                </div>

                <input type="hidden"
                       name={props.input_name}
                       value={props.value}
                       className={props.input_class}
                       data-callback={props.callback}
                       data-token={props.token}
                />

                <ul className="bf-ajax-suggest-search-results" style={{display:"none"}}> </ul>

                <ul className="bf-ajax-suggest-controls">
                    {LiValues}
                </ul>
            </div>
        )
    }
}
