import $ from 'jquery'

export default function (context, onChange) {

    var $context = $(context);

    var valueGet = function () {

        return {
            type: $(".bf-background-image-uploader-select", $context).val(),
            img: $(".bf-background-image-input", $context).val(),
        }
    };

    $context.on('click', '.bf-background-image-upload-btn', function () {

        var _this = $(this);

        var media_title = _this.attr('data-mediaTitle');
        var media_button = _this.attr('data-mediaButton');

        // prepare uploader
        var custom_uploader;

        if (custom_uploader) {
            custom_uploader.open();
            return;
        }

        custom_uploader = wp.media.frames.file_frame = wp.media({
            title: media_title,
            button: {
                text: media_button
            },
            multiple: false,
            library: {type: 'image'}
        });

        // when select pressed in uploader popup
        custom_uploader.on('select', function () {

            var attachment = custom_uploader.state().get('selection').first().toJSON();

            _this.siblings('.bf-background-image-preview').find("img").attr("src", attachment.url);

            var $input = _this.siblings('.bf-background-image-input');
            $input.val(attachment.url).change();
            $input[0].dispatchEvent(new Event('change', {bubbles: true}));

            _this.siblings('.bf-background-image-preview').show(100);
            _this.siblings('.bf-background-image-uploader-select-container').removeClass('hidden').show(100);
            _this.siblings('.bf-background-image-remove-btn').show(100);


            const value = valueGet();
            value.img = attachment.url;

            onChange(value);
        });

        // open media popup
        custom_uploader.open();

        return false;
    });
    $context.on('click', '.bf-background-image-remove-btn', function () {
        var _this = $(this),
            $input = _this.siblings('.bf-background-image-input');

        $input.val('').change();
        $input[0].dispatchEvent(new Event('change', {bubbles: true}));

        // hide remove button, select and preview
        _this.hide(100);
        _this.siblings('.bf-background-image-uploader-select-container').addClass('hidden').hide(100);
        _this.siblings('.bf-background-image-preview').hide(100);


        const value = valueGet();
        value.img = '';

        onChange(value);
    });

    $context.on('change', '.bf-background-image-uploader-select', function() {

        const value = valueGet();
        value['type'] = $(this).val();

        onChange(value);
    });

    return {
        $context,
        $img: $context.find('.bf-background-image-input'),
        $type: $context.find('.bf-background-image-uploader-select'),
    }
}