// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    impl: any;

    controlType(): string {

        return 'background_image';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        this.impl.$type.val(typeof value === "object" ? value['type'] : "");
        this.impl.$img.val(typeof value === "object" ? value['img'] : "")

        return true;
    }

    valueGet(): any {

        return {
            type: this.impl.$type.val(),
            img: this.impl.$img.val()
        };
    }

    destroy(): void {

        this.impl.$context.off('click', '.bf-background-image-upload-btn');
        this.impl.$context.off('click', '.bf-background-image-remove-btn');
    }

    dataType(): string {

        return 'object';
    }
}
