<?php

namespace BetterStudio\Component\Control;

// use standard APIs
use BetterStudio\Component\Standard\{
	Control as ControlStandard
};

use function BetterStudio\Component\Control\{
	json_decode
};

abstract class BaseDataControl extends BaseControl implements ControlStandard\HaveData {

	public function render( array $props = [], array $options = [] ): string {

		$this->options = $options;
		/// Auto decode json values.
		if ( isset( $props['value'] ) && \is_string( $props['value'] ) &&
		     \in_array( $this->data_type(), [ 'object', 'array' ], true ) ) {

			$new_value = json_decode( $props['value'] );

			if ( \is_array( $new_value ) ) {

				$props['value'] = $new_value;
			}
		}

		return parent::render( $props, $options );
	}
}
