import {Component} from "@wordpress/element"
import _ from 'lodash'
import {container_attributes} from "../../../js/HtmlHelper";


export default class extends Component {

    render() {
        const props = this.props,
            id = props.id || ("id-" + Math.random()).replace('0.', '');

        const values = _.isObject(props.value) || Array.isArray(props.value) ? props.value : {};

        return (
            <div {...container_attributes(props, "bs-control-checkbox")}>
                {
                    (props.choices||[]).map(([key, label]) => {

                        const option_id = id + "-" + key;

                        return <div className="bs-control-checkbox-option" key={key}>
                            <input type="checkbox" data-key={key} id={option_id} className={props.input_name}
                                   value={key}
                                   defaultChecked={!_.isEmpty(values[key])}
                            />
                            <label htmlFor={option_id}>{label}</label>
                        </div>
                    })
                }
            </div>
        )
    }
}
