import classnames from 'classnames'
import _ from "lodash"
import {container_attributes} from "../../../js/HtmlHelper";

export default function BF_Code(params) {

    var language_attr;

    switch ( params.language ) {

        case 'javascript' :
        case  'json' :
        case  'js' :
            language_attr = 'text/javascript';
            break;

        case 'php':
            language_attr = 'application/x-httpd-php';
            break;

        case 'css':
            language_attr = 'text/css';
            break;

        case 'sql':
            language_attr = 'text/x-sql';
            break;

        case 'xml' :
        case  'html' :
        default:
            language_attr = 'text/html';
            break;
    }

    return <div {...container_attributes(params,"bs-control-code")}>
        <textarea className={classnames("bf-code-editor", params.input_class)}
                  data-lang={language_attr}
                  defaultValue={params.value}
                  data-line-numbers={!_.isEmpty(params.line_numbers) ? "enable" : "disable"}
                  data-auto-close-brackets={!_.isEmpty(params.auto_close_brackets) ? "enable" : "disable"}
                  data-auto-close-tags={!_.isEmpty(params.auto_close_tags) ? "enable" : "disable"}
                  placeholder={params.placeholder}
        />
    </div>
}
