import $ from 'jquery'
import _ from 'lodash'

export default function (context, onChange) {

    const icon = `<svg xmlns="http://www.w3.org/2000/svg" width="16" height="15.999" viewBox="0 0 16 15.999">
  <g id="noun-eyedropper-900243" transform="translate(-150.474 -80.472)">
    <path id="Path_93" data-name="Path 93" d="M166.474,84.124l-3.652-3.652-3.969,3.969-1.111-1.111-1.111,1.111,1.111,1.111-5.874,5.874-.318,2.223-.635.634.008.008a1.111,1.111,0,0,0-.088.071,1.235,1.235,0,1,0,1.746,1.746c.027-.027.047-.058.071-.088l.008.008.635-.635,2.222-.317,5.874-5.874,1.111,1.111,1.111-1.111L162.5,88.092Zm-9.123,6.9h-2.857l4.043-4.043,1.429,1.429Z" transform="translate(0)" fill="#2c3338"/>
  </g>
</svg>`;

    const clickable = ".wp-picker-container .wp-color-result";
    const $context = $(context);
    const fixWidget = _.once(function () {

        $(this).closest('.widget-inside').find('.widget-control-save').prop('disabled', false);
    });


    $context.on('click.color', clickable, function () {

        var $parent = $(this).parent(),
            $wrapper = $parent.closest('.bs-color-picker-wrapper');

        $wrapper.find('.bs-color-picker-value').wpColorPicker({
            change: function (event) {

                /// FIX: color save issue on widgets page
                fixWidget.call(this);

                onChange(event.target.value);
            }
        }); // init the color picker

        $parent.remove(); // remove placeholder

        var $picker = $wrapper.find('.wp-picker-container:not(.bs-color-placeholder)');
        var $button = $picker.find('.wp-color-result');

        $picker.find('.wp-color-result-text').html(icon);

        const caWrapper = document.createElement('span');

        caWrapper.setAttribute('class', "color-alpha-wrapper");

        caWrapper.style.backgroundImage = $button[0].style.backgroundImage;

        $button[0].style.removeProperty('background-image');
        $button[0].style.removeProperty('background-color');

        $button[0].appendChild(caWrapper);
        const alphaEl = $button.find('.color-alpha')[0];
        alphaEl && caWrapper.insertBefore(alphaEl, caWrapper.firstChild);

        setTimeout(function () {
            $wrapper.find(clickable).click(); // open color picker
        });
    });

    return {$context};
}