// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    impl: any;

    controlType(): string {

        return 'color';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        return false;
    }

    valueGet(): any {

        return this.impl.$context.find('.bs-color-picker-value').val();
    }

    destroy(): void {

        this.impl.$context.off('click.color');
    }

    dataType(): string {

        return 'string';
    }
}
