import $ from 'jquery'

export default function (context, onChange) {

    $('.bf-editor-wrapper', context).each(function() {
        var $wrapper  = $(this),
            $editor   = $wrapper.find('.bf-editor'),
            $textarea = $wrapper.find('.bf-editor-field'),
            have_ace = typeof ace === "object";

        if( have_ace ) {

            $textarea.hide();

            $editor.css('min-height', '100px');

            var lang = $editor.data('lang'),
                max_lines = $editor.data('max-lines'),
                min_lines = $editor.data('min-lines'),
                theme = $editor.data('theme'),
                editor = ace.edit($editor[0]),
                session = editor.getSession();

            editor.setOptions({
                maxLines: max_lines,
                minLines: min_lines,
                mode: "ace/mode/" + lang
            });

            if (theme)
                editor.setTheme("ace/theme/"+theme);

            session.setUseWorker(false);

            editor.getSession().setValue($textarea.val());

            session.on('change', function (e, EditSession) {

                var value = editor.getSession().getValue();

                $textarea.val(value).trigger('bf-changed');
                $textarea[0].dispatchEvent(new Event('change',{bubbles: true}));

                onChange(value);
            });

        } else {
            $editor.remove();
            $textarea.show();
        }
    });


}