// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    context: HTMLElement;

    controlType(): string {

        return 'editor';
    }

    init(element: HTMLElement): boolean {

        this.context = element;

        oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        const textarea = this.context.querySelector('textarea');

        if (!textarea) {

            return false;
        }

        textarea.value = value;

        return true;
    }

    valueGet(): any {

        const textarea = this.context.querySelector('textarea');

        return textarea && textarea.value;
    }

    destroy(): void {

    }

    dataType(): string {

        return 'string';
    }
}
