// @flow
import {ControlBase, ControlInterface} from "../../ControlBase"
import {redirectToControl} from "../../js/Redirect";

export default class extends ControlBase implements ControlInterface {

    context: any;

    constructor(props: ?ControlProps) {

        super(props);

        this.onClick = this.onClick.bind(this);
    }

    controlType(): string {

        return 'export';
    }

    init(element: HTMLElement): boolean {

        this.context = element;

        this.context.querySelector("button")?.addEventListener("click", this.onClick);

        return true;
    }

    onClick(event: Event) {

        const panel_id = event.target?.dataset.panelId;

        redirectToControl(this.controlType(), {
            panel_id
        }, "POST");
    }

    destroy(): void {

        this.context.querySelector("button")?.removeEventListener("click", this.onClick);
    }
}
