// @flow
import {ControlBase, ControlInterface, ControlHaveData, ControlSaveValue} from "../../ControlBase"

import oldImpl from "./old"
import $ from 'jquery'

export default class extends ControlBase implements ControlInterface, ControlHaveData,ControlSaveValue {

    impl: any;

    controlType(): string {

        return 'icon_select';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        return false;
    }

    valueGet(): any {

        return {};
    }

    destroy(): void {

        this.impl.$context.off('click.init-bf-modal', '.bf-icon-modal-handler');

        const $document = $(document);

        $document.off('closing', '.better-modal.icon-modal');
        $document.off('click', '.better-modal.icon-modal .icons-list .icon-select-option');
        $document.off('click', '.better-modal.icon-modal .icons-list .icon-select-option');
        $document.off('click', '.better-modal.icon-modal .icons-list .icon-select-option .delete-icon');
        $document.off('click', '.better-modal.icon-modal .upload-custom-icon-container .section-footer .button');
        $document.off('click', '.better-icons-category-list .icon-category');
        $document.off('keyup', '#better-icon-modal .better-icons-search-input');
        $document.off('click', '#better-icon-modal .better-icons-search .clean');
        $document.off('click', '.better-modal.icon-modal .upload-custom-icon');
        $document.off('click', '.better-modal.icon-modal .upload-custom-icon-container .close-custom-icon');
        $document.off('keyup', '.better-modal.icon-modal .upload-custom-icon-container .custom-icon-fields .icon-fields input[name="icon-width"]');
        $document.off('keyup', '.better-modal.icon-modal .upload-custom-icon-container .custom-icon-fields .icon-fields input[name="icon-height"]');
    }

    dataType(): string {

        return 'object';
    }

    dynamicValuesIndexes():Array<string> {

        return [
            "icon_tag"
        ];
    }
}
