import {Component} from "@wordpress/element";
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    iconType(icon) {

        if (!icon) {
            return '';
        }

        if (icon.substr(0, 3) == 'fa-') {
            return 'fontawesome';
        } // BetterStudio Font Icon
        else if (icon.substr(0, 5) == 'bsfi-' || icon.substr(0, 5) == 'bsai-') {

            return 'bs-icons';
        } // Dashicon
        else if (icon.substr(0, 10) == 'dashicons-') {
            return 'Dashicon';
        }

        return 'custom-icon';
    }

    iconTag(icon) {

        if (!icon) {
            return '';
        }

        icon = icon.toString();

        if (icon.substr(0, 3) == 'fa-') {
            return '<i class="bf-icon fa ' + icon + '"></i>';
        } // BetterStudio Font Icon
        else if (icon.substr(0, 5) == 'bsfi-') {

            return '<i class="bf-icon ' + icon + '"></i>';
        } // Dashicon
        else if (icon.substr(0, 10) == 'dashicons-') {
            return '<i class="bf-icon dashicons dashicons-' + icon + '"></i>';
        } // Better Studio Admin Icon
        else if (icon.substr(0, 5) == 'bsai-') {
            return '<i class="bf-icon ' + icon + '"></i>';
        } // Custom Icon -> as URL


        if (icon)
            return '<i class="bf-icon bf-custom-icon bf-custom-icon-url"><img src="' + icon + '"></i>';

        return '';
    }


    render() {

        const props = this.props,
            value = props.value,
            label = value?.label || "";

        return (

            <div {...container_attributes(props,"bf-icon-modal-handler", {id: `bf-icon-modal-handler-${Math.ceil(Math.random()*1000)}`})}>

                <div className="select-options">
                    <span className="selected-option"
                          dangerouslySetInnerHTML={{__html: props.icon_tag ? props.icon_tag + label : this.iconTag(value?.icon || value?.id) + label}}>
                    </span>
                </div>

                <input type="hidden" className="icon-input" defaultValue={value?.icon}/>
                <input type="hidden" className="icon-input-font-code" defaultValue={value?.font_code}/>

                <input type="hidden" className="icon-input-type" defaultValue={value?.type}/>

                <input type="hidden" className="icon-input-height" defaultValue={value?.height}/>
                <input type="hidden" className="icon-input-width" defaultValue={value?.width}/>
            </div>
        )
    }
}
