// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"
import $ from 'jquery'

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    $context: any;

    controlType(): string {

        return 'image_radio';
    }

    init(element: HTMLElement): boolean {

        this.$context = $(element);

        $(".bf-image-radio-option", this.$context)
            .on('click.image_radio', (event) => {
                // Prevent Browser Default Behavior
                event.preventDefault();

                const $this = $(event.currentTarget),
                    value = String($this.data('id'));

                var $input = this.$context.find('input[type="hidden"]');

                $input.val(value);
                $input.change()[0].dispatchEvent(new Event('change', {bubbles: true}));

                $this.addClass('checked').siblings('.bf-image-radio-option').removeClass('checked');

                this.onChange(value);

            });
        
        return true;
    }

    valueSet(value: mixed): boolean {

        this.$context.find('input[type="hidden"]').val(value);

        return true;
    }

    valueGet(): any {

        return this.$context.find('input[type="hidden"]').val();
    }

    destroy(): void {

        $(".bf-image-radio-option", this.$context).off("click.image_radio");
    }

    dataType(): string {

        return 'string';
    }
}
