import {Component} from "@wordpress/element";
import classnames from 'classnames'
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    render() {

        const props = this.props;

        return (
            <div {...container_attributes(props, "bs-control-image-radio")}>
                <input type="hidden" value={props.value} className="image-radio-value"/>

                {(props.choices || []).map(([key, item]) => {

                    const ID = item.id || key;

                    const checked = props.value === key ? "checked" : "";

                    return (
                        <div className={classnames("bf-image-radio-option", checked)} key={ID} data-id={ID}>

                            <label>

                                <img src={item.img} alt={item.label} className={item["class"]}/>

                                {item.label && <p className="item-label">{item.label}</p>}
                            </label>
                        </div>
                    )
                })}
            </div>
        )
    }
}
