// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    impl: any;

    controlType(): string {

        return 'image_select';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        this.impl.$context.find('input[type=hidden]').val(value);

        return true;
    }

    valueGet(): any {

        return this.impl.$context.find('input[type=hidden]').val();
    }

    destroy(): void {

        this.impl.$context.off('click.image-select', '.better-select-image .image-select-option');
        this.impl.$context.off('click.image-select', '.better-select-image');
        this.impl.$context.off('click.image-select');
    }

    dataType(): string {

        return 'string';
    }
}
