import {Component} from "@wordpress/element";
import {__} from '@wordpress/i18n';
import {findChoice} from '../../utils'
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    render() {

        const {value, choices, default_text, input_class} = this.props;

        const selected = findChoice(choices || [], value);

        return (
            <div {...container_attributes(this.props, ["better-select-image", this.props.input_name])}>

                <div className="select-options">
                    <span className="selected-option">{selected.label || default_text || __('chose one...', 'better-studio')}</span>

                    <div className="better-select-image-options">
                        <ul className={'options-list bf-clearfix' + this.props["list_style"] || "grid-2-column'"}>
                            {(choices || []).map(function ([key, option]) {

                                const currentClass = value === key ? 'selected' : '';

                                return (
                                    <li data-value={key} data-label={option.label}
                                        className={'image-select-option ' + currentClass}
                                        key={key}>
                                        <img src={option.img} alt={option.label}/>
                                        <p>{option.label}</p>
                                    </li>
                                )
                            })}
                        </ul>
                    </div>
                </div>

                <input type="hidden" value={value} className={input_class}/>
            </div>
        )
    }
}
