import $ from 'jquery'

export default function (context, onChange) {

    var $context = $(context);

    $context.on('click.media', '.bf-media-upload-btn', function () {

        var _this = $(this),
            custom_uploader,
            options = _this.data('mediasettings') || {};

        if (custom_uploader) {
            custom_uploader.open();
            return;
        }

        var library = {
            title: _this.data('mediatitle'),
            //library:   wp.media.query({ type:  ['font/woff'] }),
            multiple: false,
            date: false
        };

        if (options.type) {
            library.library = wp.media.query({type: options.type});
        }

        custom_uploader = wp.media.frames.file_frame = wp.media({
            button: {
                text: _this.data('buttontext')
            },
            states: [
                new wp.media.controller.Library(library)
            ]
        });

        custom_uploader.on('select', function () {
            var attachment = custom_uploader.state().get('selection').first().toJSON();

            if (options.type && $.inArray(attachment.mime, options.type) === -1) {
                return false;
            }

            _this.siblings(':input').val(attachment.url)
                .change()[0].dispatchEvent(new Event('change', {bubbles: true}));

            onChange(attachment.url);
            custom_uploader.state().get('selection').each(function (i, o) {
            });
        });

        custom_uploader.open();

        return false;
    });

    return {$context};
}