import $ from 'jquery'

export default function (context, onChange) {

    var $context = $(context);

    $context.on('click.media_image', ".bf-media-image-upload-btn", function (e) {
        var _this = $(this),
            $_input = _this.siblings(':input');

        var custom_uploader;

        var media_title = _this.data('media-title');
        var media_button_text = _this.data('button-text');

        custom_uploader = wp.media.frames.file_frame = wp.media({
            title: media_title,
            button: {
                text: media_button_text
            },
            multiple: false
        });

        custom_uploader.on('select', function () {

            $_input.removeClass('bf-invalid-value');

            var attachment = custom_uploader.state().get('selection').first().toJSON();

            if (_this.data('data-type') === "id") {

                $_input.val(attachment.id).trigger('change');
            } else {
                $_input.val(attachment.url).trigger('change');
            }

            $_input.change();

            $_input[0].dispatchEvent(new Event('change', {bubbles: true}));

            var preview = '';

            if (typeof _this.data('size') != "undefined") {

                var var_name = _this.data('size');

                if (attachment.sizes && typeof attachment.sizes[var_name] != "undefined") {
                    preview = attachment.sizes[var_name].url;
                } else {
                    preview = attachment.url;
                }

            } else {
                preview = attachment.url;
            }

            _this.siblings('.bf-media-image-remove-btn').show();
            _this.siblings('.bf-media-image-preview').find('img').attr('src', preview);
            _this.siblings('.bf-media-image-preview').show();

            // Global change event
            _this.trigger('bf-media-image-changed', {
                'type': _this.data('data-type') || 'src',
                'name': $_input.attr('name'),
                'attachment': attachment
            });

            // field Global change event
            _this.trigger('bf-media-image-changed:' + $_input.attr('name'), {
                'type': _this.data('data-type') || 'src',
                'name': $_input.attr('name'),
                'attachment': attachment
            });

            onChange($_input.val());
        });

        custom_uploader.open();

        return false;
    });

    $context.off('keyup.media_image', '.bf-media-image-input').on('keyup', '.bf-media-image-input', function (e) {
        var _this = $(this);

        var link_regex = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;

        if (!link_regex.test(_this.val())) {
            _this.addClass('bf-invalid-value');

            _this.siblings('.bf-media-image-remove-btn').hide();
            _this.siblings('.bf-media-image-preview').find('img').attr('src', '');
            _this.siblings('.bf-media-image-preview').hide();

            return false;
        } else {
            _this.removeClass('bf-invalid-value');
        }

        _this.siblings('.bf-media-image-remove-btn').show();
        _this.siblings('.bf-media-image-preview').find('img').attr('src', _this.val());
        _this.siblings('.bf-media-image-preview').show();

        // Global change event
        _this.trigger('bf-media-image-changed', {
            'type': 'src',
            'name': _this.attr('name'),
            'attachment': _this.val()
        });

        // field Global change event
        _this.trigger('bf-media-image-changed:' + _this.attr('name'), {
            'type': 'src',
            'name': _this.attr('name'),
            'attachment': _this.val()
        });

    });

    $context.on('click.media_image', '.bf-media-image-remove-btn', function () {
        var _this = $(this);

        var $input = _this.siblings('.bf-media-image-input').val("").change();

        $input[0].dispatchEvent(new Event('change', {bubbles: true}));

        // hide remove button, select and preview
        _this.hide();
        _this.siblings('.bf-media-image-preview').hide();

        onChange("");
    });

    return {$context};
}