// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    impl: any;

    controlType(): string {

        return 'media_image';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        this.impl.$context.find('.bf-media-image-input').val(value);

        return true;
    }

    valueGet(): any {

        return this.impl.$context.find('.bf-media-image-input').val();
    }

    destroy(): void {

        this.impl.$context.off("click.media_image", ".bf-media-image-upload-btn");
        this.impl.$context.off("keyup.media_image", ".bf-media-image-input");
        this.impl.$context.off("click.media_image", ".bf-media-image-remove-btn");
    }

    dataType(): string {

        return 'string';
    }
}
