import {Component} from "@wordpress/element";
import classnames from 'classnames'
import {__} from "@wordpress/i18n"
import Icon from "../../Icon"
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    shouldComponentUpdate() {

        return false;
    }

    render() {

        const props = this.props;

        return (
            <div {...container_attributes(props, "bs-control-media-image")}>

                <input type={props.show_input ? "text" : "hidden"}
                       name={props.input_name} value={props.value}
                       placeholder={props.input_placeholder || __('Image external link...', 'better-studio')}
                       className={classnames("bf-media-image-input", "ltr", props.input_class)}
                />

                {
                    !props.hide_buttons && <a href="#"
                                              className={classnames("button", "button-primary", "bf-main-button", "bf-media-image-upload-btn", props.upload_button_class)}
                                              data-data-type={props['data-type'] || "src"}
                                              data-media-title={props.media_title || __('Upload', 'better-studio')}
                                              data-button-text={props.media_button || __('Upload', 'better-studio')}
                                              data-size={props["preview-size"] || "thumbnail"}
                    ><Icon icon="fa-upload"/> {props.upload_label}</a>
                }

                {
                    !props.hide_buttons && <a href="#"
                                              className="button bf-media-image-remove-btn"
                                              style={{display: props.value ? 'inline' : 'none'}}
                    ><Icon icon="fa-remove"/> {props.remove_label}</a>
                }

                {
                    !props.hide_preview &&
                    <div className="bf-media-image-preview" style={{display: props.value ? 'block' : 'none'}}>
                        <img src={props.preview_image_url || props.value}/>
                    </div>
                }
            </div>
        )
    }
}
