// @flow
import {ControlBase, ControlInterface} from "../../ControlBase"
import {Instances} from '../controls'

export default class extends ControlBase implements ControlInterface {

    context: any;

    controlType(): string {

        return 'multiple_controls';
    }

    init(element: HTMLElement): boolean {

        this.context = element;

        let items = this.context.querySelectorAll(".bf-multiple-controls-item-container");

        if (items.length === 0) {

            items = this.context.querySelectorAll(".bf-multiple-controls-item");
        }

        items.forEach((controlElement) => {

            const controlType = controlElement.dataset.paramType;

            if (controlType && Instances[controlType]) {

                const controlInstance = new Instances[controlType]()
                controlInstance.init(this.context);
            }
        });

        return true;
    }

    destroy(): void {
    }
}

