import {Component} from "@wordpress/element";
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    render() {

        const props = this.props,
            unique_id = props.id || ("id-" + Math.random()).replace('0.', '');

        return <div {...container_attributes(props, "bs-control-radio")}>
            {(props.choices || []).map(([key, label]) => {

                const input_id = `gutenberg-${unique_id}-${key}`;

                return <div className="bf-radio-button-option" key={key}>

                    <input type="radio" name={props.input_name || unique_id} id={input_id}
                           className={props.input_class}
                           defaultValue={key}
                           defaultChecked={props.value === key}
                    />

                    <label htmlFor={input_id}>{label}</label>
                </div>
            })}
        </div>
    }
}
