// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    impl: any;

    controlType(): string {

        return 'repeater';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        return true;
    }

    valueGet(): any {

        return [];
    }

    onChange(value: mixed): boolean {

        this.props.onChange(value);

        return true;
    }

    destroy(): void {

        this.impl.$context.off('click', '.bf-remove-repeater-item-btn');
        this.impl.$context.off('click', '.handle-repeater-item');
        this.impl.$context.off('click', '.bf-clone-repeater-item');
    }

    dataType(): string {

        return 'array';
    }
}
