// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    impl: any;

    controlType(): string {

        return 'select_popup';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.onChange(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        this.impl.$context.find('input.select-value').val(value);

        return true;
    }

    valueGet(): any {

        return this.impl.$context.find('input.select-value').val();
    }

    destroy(): void {

        this.impl.$context.off('click', '.select-popup-field');
    }

    dataType(): string {

        return 'string';
    }
}
