import {Component} from "@wordpress/element";
import {__} from "@wordpress/i18n";
import lodash from "lodash"
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    render() {

        const props = this.props,
            texts = lodash.isObject(props.texts) ? props.texts : {};

        let current = {
            key: "",
            label: "",
            img: ""
        };

        if (! lodash.isEmpty(props.value)) {

            if (props.options && lodash.isObject(props.options[props.value])) {

                current = props.options[props.value];
                current.key = props.value;
            }
        }

        const select_style = lodash.isEmpty( props.select_style ) ? 'creative' : 'regular-select';

        return (

            <div {...container_attributes(props,['better-' + select_style + '-style', "select-popup-field","bf-clearfix", props.input_name] , {"data-heading":props.name})}>
                <div className="select-popup-selected-image">
                    <img src={current.current_img || current.img}/>
                </div>
                <div className="select-popup-selected-info">
                    <div className="active-item-text">
                        {texts.box_pre_title || __('Active item', 'better-studio') }
                    </div>
                    <div className="active-item-label">{current.label}</div>

                    <a href="#" className="button button-primary">
                        {texts.box_button || __('Change', 'better-studio')}
                    </a>
                </div>

                <script type="application/json" className="select-popup-data">{JSON.stringify(props.data2print)}</script>

                <input type="hidden" name={props.input_name} value={current.key} className="select-value" />
            </div>
        )
    }
}
