// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    element: any;

    controlType(): string {

        return 'sorter';
    }

    init(element: HTMLElement): boolean {

        this.element = element;

        oldImpl(element, (value) => this.valueSet(value));

        return true;
    }

    valueSet(value: mixed): boolean {

        const input = this.element.querySelector("input[type=hidden]");

        input.value = JSON.stringify(value);
        this.onChange(value);
        input.dispatchEvent(new Event('change', {bubbles: true}));

        return true;
    }

    valueGet(): Array<Object> {

        try {

            return JSON.parse(this.element.querySelector("input[type=hidden]").value);

        } catch (e) {

        }

        return [];
    }

    destroy(): void {

    }

    dataType(): string {

        return 'array';
    }
}
