// @flow
import {ControlBase, ControlInterface, ControlHaveData} from "../../ControlBase"

import oldImpl from "./old"

export default class extends ControlBase implements ControlInterface, ControlHaveData {

    impl: any;

    controlType(): string {

        return 'switch';
    }

    init(element: HTMLElement): boolean {

        this.impl = oldImpl(element, (value) => this.valueSet(value));

        return true;
    }

    valueSet(value: mixed): boolean {


        this.impl.$context.find('.checkbox').val(String(value));

        this.onChange(String(value));

        return true;
    }

    valueGet(): any {

        return this.impl.$context.find('.checkbox').val();
    }

    destroy(): void {

        this.impl.$context.off('click.switch', '.cb-enable');
        this.impl.$context.off('click.switch', '.cb-disable');
    }

    on() {

        this.impl.$context.find('a.cb-enable').click();
    }

    off() {

        this.impl.$context.find('a.cb-disable').click();
    }

    dataType(): string {

        return 'string';
    }
}
