import {Component} from "@wordpress/element";
import classnames from 'classnames'
import {__} from '@wordpress/i18n';
import {container_attributes} from "../../../js/HtmlHelper";
import Icon from "../../Icon";

export default class extends Component {

    shouldComponentUpdate() {

        return false;
    }

    render() {

        const props = this.props,
            labels = this.props.labels || {};

        return (

            <div {...container_attributes(props, "bf-term-select-field")}>
                <div className="bf-field-term-select-wrapper bf-field-term-select-deferred"
                     data-taxonomy={props.taxonomy || "category"}
                >{
                    __('Loading...', 'better-studio')
                }</div>

                <div className="bf-field-term-select-help">
                    <label>{labels.help || __('Help: Click on check box to', 'better-studio')}</label>
                    <br/>

                    <div className="bf-checkbox-multi-state" data-current-state="none">
                        <span data-state="none"></span>
                    </div>
                    <label>{labels.not_selected || __('Not Selected', 'better-studio')}</label>

                    <br/>
                    <div className="bf-checkbox-multi-state" data-current-state="active">
						<span data-state="active" className="bf-checkbox-active">
                           <Icon icon="fa-check" className="icon"/>
                   		</span>
                    </div>
                    <label>{labels.selected || __('Selected', 'better-studio')}</label>

                    <br/>
                    <div className="bf-checkbox-multi-state" data-current-state="deactivate">
    					<span data-state="deactivate" className="bf-checkbox-active">
                            <Icon icon="fa-times" className="icon"/>
    					</span>
                    </div>

                    <label>{labels.excluded || __('Excluded', 'better-studio')}</label>
                </div>

                <input type="hidden" value={props.value} name={props.input_name}
                       className={classnames("bf-term-select-value", props.input_class)}/>
            </div>
        )
    }
}
