import {Component} from "@wordpress/element";
import _ from 'lodash'
import {container_attributes} from "../../../js/HtmlHelper";

export default class extends Component {

    shouldComponentUpdate() {

        return false;
    }

    render() {

        const props = this.props,
            havePrefix = !_.isEmpty(props.prefix),
            haveSuffix = !_.isEmpty(props.suffix);

        const value = props['special-chars'] ? this.specialCharsDecode(props.value) : props.value;

        return <div {...container_attributes(props,[
            "bs-control-text",
            {
                "bf-field-with-prefix": havePrefix,
                "bf-field-with-suffix": haveSuffix,
                "rtl": !_.isEmpty(props.rtl),
                "ltr": !_.isEmpty(props.ltr)
            }
        ])}>
            {
                havePrefix && <span>{props.prefix}</span>
            }

            <input type="text" name={props.input_name}
                   className={props.input_class}
                   placeholder={props.placeholder}
                   defaultValue={value}/>

            {
                haveSuffix && <span>{props.suffix}</span>
            }
        </div>
    }

    specialCharsDecode(str) {

        if (str == null) return '';

        return String(str).
            replace('&amp;', '&').
            replace('&lt;', '<').
            replace('&gt;', '>').
            replace('&quot;', '"').
            replace('&#039;', '\'').
            replace('&lsqb;', '[').
            replace('&rsqb;', ']').
            replace('&Hat;', '^').
            replace('&sol;', '/').
            replace('&lpar;', '(').
            replace('&rpar;', ')').
            replace('&plus;', '+').
            replace('&nbsp;', ' ').
            replace('&copy;', '©');
    }
}
