/**
 * @link https://stackoverflow.com/questions/3446170/escape-string-for-use-in-javascript-regex/6969486#6969486
 */
function escapeRegExp(string) {
    return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
}

function extractValue(key, text) {

    const match = text.match(new RegExp(`${escapeRegExp(key)}\\s*:\\s*([^;]+)`));

    return match && match[1];
}

export function cssObject(cssText) {

    const el = document.createElement('a');
    el.style.cssText = cssText;

    const obj = {};

    Object.entries(el.style).map(([key, value]) => {

        if (!isNaN(key)) {

            if (value.startsWith('--')) { // is css variable

                key = value;
                value = extractValue(key, el.style.cssText);
            }
        }

        if (value && value !== "initial" && isNaN(key)) {

            obj[key] = value;
        }
    });

    return obj;
}

export function findChoice(choices, key) {

    for (const index in choices) {

        const current_key = choices[index] && choices[index][0];

        if (current_key == key) {

            return choices[index][1] || {};
        }
    }

    return {};
}