const path = require("path");
const WebpackConcatPlugin = require('webpack-concat-files-plugin');
const UglifyJsPlugin = require('terser-webpack-plugin');

module.exports = (env, options) => {

    const isDev = options.mode === "development";

    const config = {
        entry: path.resolve(__dirname, "libs/deps/index.js"),
        output: {
            path: path.resolve(__dirname, "dist"),
        },
        optimization: {
            minimize: !isDev,
            minimizer: [new UglifyJsPlugin()],
        },
        plugins: [
            new WebpackConcatPlugin({
                bundles: [
                    {
                        dest: './dist/controls-dependencies.js',
                        src: './libs/deps/**/*.js',
                    },
                ],
                allowWatch: isDev,
                allowOptimization: !isDev
            }),
        ],
        target: ['web', 'es5'],
    };

    if (isDev) {

        config.devtool = "source-map";
    }

    return config;
};
