<?php

namespace BetterStudio\Utils\ArrayUtil;

use BadMethodCallException;

trait CanMergeItems {

	/**
	 * Merge new items with the collection.
	 *
	 * @string 1.1.0
	 * @return self new list instance
	 */
	public function merge( array $new_items ): self {

		if ( ! $this instanceof CollectionBase ) {

			throw new BadMethodCallException( sprintf( '%s only works on collections.', __METHOD__ ) );
		}

		$this->data = array_merge( $this->data, $new_items );

		return $this;
	}
}
