<?php

namespace BetterStudio\Utils\ArrayUtil;

/**
 * Helper methods to work with collections.
 *
 * @package BetterStudio\Utils\ArrayUtil
 */
final class Util {

	/**
	 * Get a value by index.
	 *
	 * @param array      $array
	 * @param string|int $index
	 * @param mixed      $default
	 *
	 * @since 1.0.0
	 * @return mixed null on failure other type on success.
	 */
	public static function get( array $array, $index, $default = null ) {

		$value = CollectionRef::instance( $array )->get( $index );

		return $value ?? $default;
	}

	/**
	 * Store value in given index.
	 *
	 * @param array      $array
	 * @param string|int $index
	 * @param mixed      $value
	 *
	 * @since 1.0.0
	 */
	public static function set( array &$array, $index, $value ): void {

		CollectionRef::instance( $array )->set( $index, $value );

	}
}
