<?php

namespace BetterStudio\Component\Control\Core\Helper;

class HtmlHelper {

	public static function tag_attributes( array $attributes, bool $return = false ): ?string {

		$output = ' ';

		if ( isset( $attributes['class'] ) ) {

			if ( is_array( $attributes['class'] ) ) {

				$attributes['class'] = implode( ' ', array_filter( $attributes['class'] ) );
			}

			$attributes['class'] = self::sanitize_html_classes( $attributes['class'] );
		}

		foreach ( $attributes as $key => $attribute ) {


			if ( is_array( $attribute ) || is_object( $attribute ) ) {

				$attribute = wp_json_encode( $attribute );
			}

			$output .= sprintf( ' %s="%s"', sanitize_key( $key ), esc_attr( $attribute ) );
		}

		$output = ltrim( $output );

		if ( ! $return ) {

			echo $output;

			return null;
		}

		return $output;
	}


	public static function sanitize_html_classes( string $classes ): string {
		// Strip out any %-encoded octets.
		$sanitized = preg_replace( '|%[a-fA-F0-9][a-fA-F0-9]|', '', $classes );

		// Limit to A-Z, a-z, 0-9, '_', '-'. and space
		return preg_replace( '/[^\sA-Za-z0-9_-]/', '', $sanitized );
	}
}
