<?php

namespace BetterStudio\Component\Control\Import;

// use current component
use BetterStudio\Component\Control as LibRoot;

// use standard APIs
use BetterStudio\Component\Standard\{Control as ControlStandard, Control\HandleAjaxRequest};

class ImportControl extends LibRoot\BaseControl implements
	ControlStandard\WillModifyProps,
	ControlStandard\HaveAjaxHandler,
	ControlStandard\HaveScripts,
	ControlStandard\HaveStyles {

	/**
	 * @since 1.0.0
	 * @return string
	 */
	public function control_type(): string {

		return 'import';
	}

	/**
	 * @since 1.0.0
	 * @return string
	 */
	public function template_dir(): string {

		return __DIR__ . '/templates';
	}

	public function styles_list(): array {

		return [
			[
				'id' => 'buttons',
			],
		];
	}

	public function scripts_list(): array {

		return [
			[
				'id' => 'jquery-ui-core',
			]
		];
	}

	public function ajax_handler(): HandleAjaxRequest {

		return new ImportAjaxHandler();
	}

	public function modify_props( array $props ): array {

		$props['token'] = wp_create_nonce( 'import:' . ( $props['panel_id'] ?? '' ) );

		return $props;
	}
}
