<?php

namespace BetterStudio\Component\Control\Slider;

use BetterStudio\Component\Control as LibRoot;

// use standard APIs
use BetterStudio\Component\Standard\{
	Control as ControlStandard
};

class SliderControl extends LibRoot\BaseDataControl implements ControlStandard\HaveScripts {

	/**
	 * @since 1.0.0
	 * @return string
	 */
	public function control_type(): string {

		return 'slider';
	}

	/**
	 * @since 1.0.0
	 * @return string
	 */
	public function template_dir(): string {

		return __DIR__ . '/templates';
	}

	public function scripts_list(): array {

		return [
			[
				'id' => 'jquery-ui-slider',
			]
		];
	}

	public function data_type(): string {

		return 'number';
	}
}
