<?php

namespace BetterStudio\Component\Control\TermSelect;

use BetterStudio\Component\Control as LibRoot;

// use standard APIs
use BetterStudio\Component\Standard\{
	Control as ControlStandard
};

class TermSelectControl extends LibRoot\BaseDataControl implements ControlStandard\HaveAjaxHandler {

	/**
	 * @since 1.0.0
	 * @return string
	 */
	public function template_dir(): string {

		return __DIR__ . '/templates';
	}

	/**
	 * @since 1.0.0
	 * @return string
	 */
	public function control_type(): string {

		return 'term_select';
	}

	public function ajax_handler(): ControlStandard\HandleAjaxRequest {

		return new TermSelectAjaxHandler();
	}

	public function data_type(): string {

		return 'string';
	}
}