<?php //phpcs:disable

$title   = ! empty( $title ) ? $title : __( 'Content Protected!', 'wpshield-content-protector' );
$content = ! empty( $content ) ? $content : __( 'The content of this website cannot be copied!', 'wpshield-content-protector' );
$icon    = ! empty( $icon ) ? bf_get_icon_tag( $icon, 'cp-icon' ) : bf_get_icon_tag( 'bsfi-warning-1', 'cp-icon' );
$color   = ! empty( $color ) ? $color : '#DC1F1F';

if ( function_exists( 'esc_html' ) ) {
	$title   = esc_html( $title );
	$content = esc_html( $content );
}

?>
<div class="cp-alert cp-alert-1" style="--cp-primary-color: <?php echo $color; ?>">
    <div class="cp-alert-inner" role="alert">
		<?php

		echo bf_get_icon_tag( 'bsfi-close', 'cp-close' );

		if ( ! empty( $icon ) ) {
			echo $icon;//before escaped
		}

		?>
        <h4 class="cp-alert-heading"><?php esc_html_e( $title ) ?></h4>

        <p class="cp-alert-message"><?php esc_html_e( $content ) ?></p>
    </div>
</div>
